require 'json'
require 'thor'
require 'rainbow'
require 'rest-client'
require 'terminal-notifier'
require 'awesome_print'

module FakeGrid
  class Cli < Thor

    desc "fake_sendgrid [SERVER]", "sends fake sendgrid event to [SERVER]"
    options :cr_id => :required, :email => :required, :event => :required
    def fake_sendgrid(server)
      dest = "http://#{server}/api/sendgrid/event"
      fake = FakeSendgrid.new dest, cr_id: options[:cr_id], email: options[:email], event: options[:event]
      puts "Success #{fake.process!}" if fake.process!
    end
  end

  class FakeSendgrid

    def initialize(dest, options={})
      @dest = dest
    end

    def process!
      @request = RestClient.post @dest, sendgrid_data(@event), :content_type => :json
      @request.code
    end

    private

    def sendgrid_data(event)
      [
        {
          email: options[:email],
          cr_id: options[:cr_id],
          event: options[:event]
        }
      ].to_json
    end
  end
end